package eu.eudat.file.transformer.models.descriptiontemplate.definition;

import eu.eudat.file.transformer.enums.FieldValidationType;
import eu.eudat.file.transformer.models.descriptiontemplate.DescriptionTemplateXmlModel;
import eu.eudat.file.transformer.models.descriptiontemplate.definition.fielddata.BaseFieldDataXmlModel;
import jakarta.xml.bind.annotation.XmlRootElement;
import jakarta.xml.bind.annotation.XmlType;

import java.util.List;

@XmlType(namespace = "description-template")
public class FieldXmlModel {

	private String id;
	private Integer ordinal;
	private String numbering; //TODO maybe remove
	private List<String> schematics;
	private String defaultValue;
	private List<RuleXmlModel> visibilityRules;
	private List<FieldValidationType> validations;
	private Boolean includeInExport;
	private BaseFieldDataXmlModel data;

	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Integer getOrdinal() {
		return ordinal;
	}

	public void setOrdinal(Integer ordinal) {
		this.ordinal = ordinal;
	}

	public String getNumbering() {
		return numbering;
	}

	public void setNumbering(String numbering) {
		this.numbering = numbering;
	}

	public List<String> getSchematics() {
		return schematics;
	}

	public void setSchematics(List<String> schematics) {
		this.schematics = schematics;
	}

	public String getDefaultValue() {
		return defaultValue;
	}

	public void setDefaultValue(String defaultValue) {
		this.defaultValue = defaultValue;
	}

	public List<RuleXmlModel> getVisibilityRules() {
		return visibilityRules;
	}

	public void setVisibilityRules(List<RuleXmlModel> visibilityRuleXmlModels) {
		this.visibilityRules = visibilityRuleXmlModels;
	}

	public List<FieldValidationType> getValidations() {
		return validations;
	}

	public void setValidations(List<FieldValidationType> validations) {
		this.validations = validations;
	}

	public Boolean getIncludeInExport() {
		return includeInExport;
	}

	public void setIncludeInExport(Boolean includeInExport) {
		this.includeInExport = includeInExport;
	}

	public BaseFieldDataXmlModel getData() {
		return data;
	}

	public void setData(BaseFieldDataXmlModel data) {
		this.data = data;
	}
}
