package eu.eudat.file.transformer.utils.mapper.descriptiontemplate;

import eu.eudat.file.transformer.models.descriptiontemplate.definition.fielddata.*;

public class FieldDataXmlMapper {

    public static AutoCompleteSingleDataXmlModel toAutocompleteXml(AutoCompleteSingleDataFileTransformerModel fileModel) {
        AutoCompleteSingleDataXmlModel xmlModel = new AutoCompleteSingleDataXmlModel();

        xmlModel.setUrl(fileModel.getUrl());
        xmlModel.setAutoCompleteOptions(toComboBoxXml(fileModel.getAutoCompleteOptions()));

        return xmlModel;
    }

    public static ComboBoxOptionXmlModel toComboBoxXml(ComboBoxOptionFileTransformerModel fileModel) {
        ComboBoxOptionXmlModel xmlModel = new ComboBoxOptionXmlModel();

        xmlModel.setUri(fileModel.getUri());
        xmlModel.setLabel(fileModel.getLabel());
        xmlModel.setValue(fileModel.getValue());
        xmlModel.setSource(fileModel.getSource());

        return xmlModel;
    }

    public static UploadOptionXmlModel toUploadXml(UploadOptionFileTransformerModel fileModel) {
        UploadOptionXmlModel xmlModel = new UploadOptionXmlModel();
        xmlModel.setLabel(fileModel.getLabel());
        xmlModel.setValue(fileModel.getValue());
        return xmlModel;
    }

    public static RadioBoxOptionXmlModel toRadioBoxXml(RadioBoxOptionFileTransformerModel fileModel) {
        RadioBoxOptionXmlModel xmlModel = new RadioBoxOptionXmlModel();
        xmlModel.setLabel(fileModel.getLabel());
        xmlModel.setValue(fileModel.getValue());
        return xmlModel;
    }
}
